      SUBROUTINE NERS_FETCH ( NERS, IUER )
! ************************************************************************
! *                                                                      *
! *   Routine  NERS_GET_EOP
! *                                                                      *
! *  ### 16-JUN-2016  NERS_GET_EOP  v1.2 (c) L. Petrov  06-MAY-2017 ###  *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE 
      INCLUDE   'ners.i'
      INCLUDE   'astro_constants.i'
      TYPE     ( NERS__TYPE ) :: NERS
      INTEGER*4  IUER 
      CHARACTER  STR*128, COM_STR*512, TEMP_NERS_FCS*128, TEMP_NERS_LOG*128, &
     &           CONN_TIMEOUT_STR*12, READ_TIMEOUT_STR*12
      INTEGER*4  IS, J1, J2, IER
      INTEGER*4, EXTERNAL :: ILEN, I_LEN, GET_PID
      REAL*8,    EXTERNAL :: TIME
      INTEGER*4, EXTERNAL :: SYSTEM
!
      WRITE ( UNIT=STR(1:5), FMT='(I5.5)' ) GETPID()
      TEMP_NERS_FCS = TRIM(NERS%CNF%FCS_FILE)//'_'//STR(1:5)
      TEMP_NERS_LOG = '/tmp/ners__'//STR(1:5)//'.log'
      WRITE ( UNIT=CONN_TIMEOUT_STR, FMT='(F12.1)' ) NERS%CNF%CONN_TIMEOUT 
      WRITE ( UNIT=READ_TIMEOUT_STR, FMT='(F12.1)' ) NERS%CNF%READ_TIMEOUT 
      CONN_TIMEOUT_STR = ADJUSTL ( CONN_TIMEOUT_STR )
      READ_TIMEOUT_STR = ADJUSTL ( READ_TIMEOUT_STR )
!
      DO 410 J1=1,NERS%CNF%N_TRIES
         DO 420 J2=1,NERS%CNF%N_URL
            COM_STR = 'wget'// &
     &                ' -c'// &
     &                ' --no-use-server-timestamps'// &
     &                ' --dns-timeout='//TRIM(CONN_TIMEOUT_STR)// &
     &                ' --connect-timeout='//TRIM(CONN_TIMEOUT_STR)// &
     &                ' --read-timeout='//TRIM(READ_TIMEOUT_STR)// &
     &                ' -O '//TRIM(TEMP_NERS_FCS)// &
     &                ' '//TRIM(NERS%CNF%URL(J1))//' > '// &
     &                ' '//TRIM(TEMP_NERS_LOG)//' 2>&1'
            IS = SYSTEM ( TRIM(COM_STR)//CHAR(0) )
            IF ( IS == 0 ) THEN
                 CALL RENAME ( TRIM(TEMP_NERS_FCS)//CHAR(0), TRIM(NERS%CNF%FCS_FILE)//CHAR(0) )
                 CALL UNLINK ( TRIM(TEMP_NERS_LOG)//CHAR(0) )
                 CALL ERR_LOG ( 0, IUER )
                 RETURN 
            END IF
 420     CONTINUE 
         IF ( J1 .NE. NERS%CNF%N_TRIES ) THEN
              CALL SLEEP ( IDNINT ( NERS%CNF%CONN_TIMEOUT ) )
         END IF
 410  CONTINUE 
!
      CALL ERR_LOG ( 4342, IUER, 'NERS_FETCH', 'Error in an attempt to '// &
     &    'download EOP from the remote server' )
      IS = SYSTEM ( 'cat '//TRIM(TEMP_NERS_LOG)//CHAR(0) )
      CALL UNLINK ( TRIM(TEMP_NERS_LOG)//CHAR(0) )
!
      RETURN
      END  SUBROUTINE  NERS_FETCH  !#!#
