      SUBROUTINE NERS_GET_SPL ( NERS, TIM_TAI, CPAR, L_PAR, PARS, IUER )
! ************************************************************************
! *                                                                      *
! *   Routine  NERS_GET_SPL
! *                                                                      *
! *  ### 18-JUN-2016  NERS_GET_SPL  v1.0 (c) L. Petrov  18-JUN-2016 ###  *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE 
      INCLUDE   'astro_constants.i'
      INCLUDE   'ners.i'
      INTEGER*4  IUER
      TYPE     ( NERS__TYPE ) :: NERS
      INTEGER*4  L_PAR
      CHARACTER  CPAR*(*)
      REAL*8     TIM_TAI, PARS(NERS__MPAR)
      REAL*8     TIM_EPS
      PARAMETER  ( TIM_EPS = 1.D-6 ) 
      REAL*8,    ALLOCATABLE :: TEMP_ARR(:)
      REAL*8     TIM_BEG, TIM_END, TIM_STEP, DEPS, DPSI, &
     &           EVEC(3,0:2), HEO_VEC(3,0:2), MAT_ROT(3,3,0:2), &
     &           DER_EOP(2,NERS__MEL), TIM
      REAL*8       LOD__TO__ER3
      PARAMETER  ( LOD__TO__ER3 =  1.00273781191135448E0*OM__EAR**2/PI2 )
      INTEGER*4  J1, J2, J3, J4, J5, J6, J7, IND, IER
      INTEGER*4, EXTERNAL :: IXMN8
      REAL*8,    EXTERNAL :: EBSPL_VAL_R8, EBSPL_DER_R8, EBSPL_DR2_R8
!
      IF ( NERS%EXP_STATUS .NE. NERS__COMP ) THEN
           CALL ERR_LOG ( 4811, IUER, 'NERS_GET_SPL', 'Trap of '// &
     &         'internal control: NERS spline coefficients have not '// &
     &         'been computed' )
           RETURN 
      END IF
      TIM = TIM_TAI - NERS%TIM_START
      IF ( DABS( TIM_TAI - NERS%TIM_START ) < TIM_EPS ) THEN
           IND = 1
        ELSE IF ( DABS( TIM_TAI - NERS%TIM_STOP ) < TIM_EPS ) THEN
           IND = NERS%EXP%L_NOD
        ELSE IF ( TIM_TAI .GE. NERS%TIM_START - TIM_EPS .AND. &
     &            TIM_TAI .LE. NERS%TIM_STOP  + TIM_EPS       ) THEN
           IND = IXMN8 ( NERS%EXP%L_NOD, NERS%EXP%ARG, TIM_TAI - NERS%TIM_START )
        ELSE
           WRITE ( 6, * ) 'TIM_START/TIM_STOP: ', NERS%TIM_START, NERS%TIM_STOP 
           WRITE ( 6, * ) 'TIM_TAI:            ', TIM_TAI
           CALL ERR_LOG ( 4812, IUER, 'NERS_GET_SPL', 'Trap of '// &
     &         'internal control: time epoch is out of range' )
           RETURN 
      END IF
!
      IF ( CPAR == 'mat' ) THEN
           L_PAR = 9
           DO 410 J1=1,9
              PARS(J1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J1+8) )
 410       CONTINUE 
        ELSE IF ( CPAR == 'matr' ) THEN
           L_PAR = 9
           DO 420 J2=1,9
              PARS(J2) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J2+8) )
 420       CONTINUE 
        ELSE IF ( CPAR == 'matrr' ) THEN
           L_PAR = 9
           DO 430 J3=1,9
              PARS(J3) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J3+8) )
 430       CONTINUE 
        ELSE IF ( CPAR == 'matall' ) THEN
           L_PAR = 27
           DO 440 J4=1,9
              PARS(J4)    = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                     NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J4+8) )
              PARS(J4+9)  = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                     NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J4+8) )
              PARS(J4+18) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                     NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,J4+8) )
 440       CONTINUE 
        ELSE IF ( CPAR == 'e1' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'e2' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'e3' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )
        ELSE IF ( CPAR == 'e1r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'e2r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'e3r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )
        ELSE IF ( CPAR == 'e1rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'e2rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'e3rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )
        ELSE IF ( CPAR == 'h1' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
        ELSE IF ( CPAR == 'h2' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
        ELSE IF ( CPAR == 'h3' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
        ELSE IF ( CPAR == 'heo' ) THEN
           L_PAR = 3
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
           PARS(3) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
        ELSE IF ( CPAR == 'heorr' ) THEN
           L_PAR = 9
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
           PARS(3) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
           PARS(4) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
           PARS(5) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
           PARS(6) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
           PARS(7) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
           PARS(8) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
           PARS(9) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
        ELSE IF ( CPAR == 'h1r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
        ELSE IF ( CPAR == 'h2r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
        ELSE IF ( CPAR == 'h3r' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
        ELSE IF ( CPAR == 'h1rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H1) )
        ELSE IF ( CPAR == 'h2rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H2) )
        ELSE IF ( CPAR == 'h3rr' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                                  NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__H3) )
        ELSE IF ( CPAR == 'xpol' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'ypol' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'xpolr' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'ypolr' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'xpolrr' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
        ELSE IF ( CPAR == 'ypolrr' ) THEN
           L_PAR = 1
           PARS(1) = EBSPL_DR2_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
        ELSE IF ( CPAR == 'ut1mtai' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
        ELSE IF ( CPAR == 'ut1rat' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
        ELSE IF ( CPAR == 'lod' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              LOD__TO__ER3
        ELSE IF ( CPAR == 'dpsi' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DP) )
        ELSE IF ( CPAR == 'deps' ) THEN
           L_PAR = 1
           PARS(L_PAR) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DE) )
        ELSE IF ( CPAR == 'nut' ) THEN
           L_PAR = 2
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DP) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DE) )
        ELSE IF ( CPAR == 'nutr' ) THEN
           L_PAR = 4
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DP) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DE) )
           PARS(3) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DP) )
           PARS(4) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DE) )
        ELSE IF ( CPAR == 'eop3' ) THEN
           L_PAR = 3
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
           PARS(3) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
        ELSE IF ( CPAR == 'eop3r' ) THEN
           L_PAR = 6
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
           PARS(3) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
           PARS(4) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
           PARS(5) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
           PARS(6) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
        ELSE IF ( CPAR == 'eops' ) THEN
           L_PAR = 8
           PARS(1) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
           PARS(2) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
           PARS(3) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
           PARS(4) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E2) )
           PARS(5) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E1) )
           PARS(6) = EBSPL_DER_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__E3) )/ &
     &                              UT1__TO__E3
           PARS(7) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DP) )
           PARS(8) = EBSPL_VAL_R8 ( NERS%EXP%L_NOD, NERS__MDEG, TIM, &
     &                              NERS%EXP%ARG, NERS%EXP%BSPL(1-NERS__MDEG,NERS__DE) )
        ELSE
           CALL ERR_LOG ( 4813, IUER, 'NERS_GET_SPL', 'Earth orientation '// &
     &         'parameter name '//TRIM(CPAR)//' is not supported' )
           RETURN 
      END IF
!
      CALL ERR_LOG ( 0, IUER ) 
      RETURN
      END  SUBROUTINE  NERS_GET_SPL  !#!  
