      PROGRAM    UT1CTAI
! ************************************************************************
! *                                                                      *
! *   Routine  UT1CTAI
! *                                                                      *
! *  ### 22-JUN-2016    UT1CTAI    v1.0 (c)  L. Petrov  22-JUN-2016 ###  *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE 
      INCLUDE   'astro_constants.i'
      INCLUDE   'ners.i'
      INCLUDE   'ners_local.i'
      TYPE     ( NERS__TYPE ) :: NERS
      CHARACTER  NERS_CONFIG*128, CPARM*16
      REAL*8     UTC_CUR, UTC_M_TAI
      LOGICAL*1  FL_CUR, LEX
      INTEGER*4  J1, J2, J3, IS, UNIX_DATE, NS, IVRB, MJD, NOPT, L_PAR, IUER
      INTEGER*8  SIZE_I8
      INTEGER*4, EXTERNAL :: ILEN, I_LEN, TIME, FILE_INFO
      CHARACTER, EXTERNAL :: TIM_TO_DATE*23
!
      CALL GETENVAR ( 'HOME', NERS_CONFIG )
      NERS_CONFIG = TRIM(NERS_CONFIG)//'/.ners_config'
      INQUIRE ( FILE=NERS_CONFIG, EXIST=LEX )
      IF ( .NOT. LEX ) THEN
           NERS_CONFIG = NERS__CONFIG
      END IF
!
      IUER = -1
      CALL NERS_INIT ( NERS_CONFIG, NERS, -1.0D0, -1.0D0, IUER )
      IF ( IUER .NE. 0 ) THEN
           IUER = -1
           CALL ERR_LOG ( 4001, IUER, 'UT1CTAI', 'Error in initializing '// &
     &         'NERS data structure' )
           CALL EXIT ( 1 )
      END IF
!
      IS = FILE_INFO ( TRIM(NERS%CNF%FCS_FILE)//CHAR(0), UNIX_DATE, &
     &                 SIZE_I8 )
      IF ( IS .NE. 0 .OR. (TIME(%VAL(0)) - UNIX_DATE) > NERS%CNF%AGE_FCS ) THEN
           IUER = -1
           CALL NERS_FETCH ( NERS, IUER )
           IF ( IUER .NE. 0 ) THEN
                CALL ERR_LOG ( 4002, IUER, 'UT1CTAI', 'Error in '// &
     &               'an attempt to retrieve NERS forecast parameters '// &
     &               'form the remote server' )
                CALL EXIT ( 1 )
           END IF
      END IF
!
      IUER = -1
      CALL NERS_LOAD ( NERS, IUER )
      IF ( IUER .NE. 0 ) THEN
           CALL ERR_LOG ( 4003, IUER, 'UT1CTAI', 'Error in '// &
     &         'an attempt to retrieve NERS forecast parameters '// &
     &         'form the remote server' )
           RETURN 
      END IF
!
      UTC_CUR = TIME ( %VAL(0) ) - UNIX__J2000_UTC
!
      IUER = -1
      CALL NERS_GET_UTCMTAI ( NERS, UTC_CUR, UTC_M_TAI, IUER )
      IF ( IUER .NE. 0 ) THEN
           IUER = -1
           CALL ERR_LOG ( 4004, IUER, 'UT1CTAI', 'Error in getting '// &
     &         'UTC minus TAI' )
           CALL EXIT ( 1 )
      END IF
      WRITE ( 6, 110 ) UTC_M_TAI
 110  FORMAT ( F5.1 )
      END  PROGRAM    UT1CTAI  !#!  
